<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/algorithms/pregelPageR.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_709bf4bcb4365c9d292f00f24fad6060.html">algorithms</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pregelPageR.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="pregelPageR_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#ifndef PREGELPAGER_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#define PREGELPAGER_HPP_</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;types.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="edge_8hpp.html">edge.hpp</a>&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="PregelVertex_8hpp.html">PregelVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Message_8hpp.html">Message.hpp</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="PregelCombiner_8hpp.html">PregelCombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>&gt;</div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classVertexP__pageR.html">   46</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexP__pageR.html">VertexP_pageR</a>:</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keyword">public</span> <a class="code" href="classVertexP.html">VertexP</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;, uint32, uint32, DblMessage&gt;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;{</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;</a>, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE   MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;</a>, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;::LOCAL_MESSAGE_BUF  LOCAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;</a>, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classVertexP__pageR.html#a6771c90137d1f5eda92db5e89a43bdc7">   57</a></span>&#160;    <span class="keyword">static</span> uint32 <a class="code" href="classVertexP__pageR.html#a6771c90137d1f5eda92db5e89a43bdc7">numVertices</a>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classVertexP__pageR.html#a40963978f9fc2077a6cbc48867c58d45">   61</a></span>&#160;    <a class="code" href="classVertexP__pageR.html#a40963978f9fc2077a6cbc48867c58d45">VertexP_pageR</a>(uint32 key):<a class="code" href="classVertexP.html">VertexP</a>&lt;char, double, <a class="code" href="classEdgeBase.html">TIGLContainersEdgeBase</a>&lt;uint32&gt;, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;(key, true, false){}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    ~<a class="code" href="classVertexP__pageR.html">VertexP_pageR</a>(){}</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classVertexP__pageR.html#ae5353e8947658bd2c9e42a68bcc17c37">   72</a></span>&#160;    uint32 <a class="code" href="classVertexP__pageR.html#ae5353e8947658bd2c9e42a68bcc17c37">compute</a>(MESSAGE_BUF_TYPE * pIn, LOCAL_MESSAGE_BUF * pOut, uint32 numMessages)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordtype">double</span> newRank = 0.0;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; 1)<span class="comment">//if(pIn-&gt;size() &gt; 1)</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelPageR compute: numMessages(&quot;</span> &lt;&lt; this-&gt;getId() &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl;<span class="comment">//cout&lt;&lt;&quot;!!! Warning : numMessages(&quot; &lt;&lt; this-&gt;getId() &lt;&lt; &quot;) = &quot; &lt;&lt; pIn-&gt;size() &lt;&lt; endl;</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; pIn-&gt;size())<span class="comment">//if(pIn-&gt;size() &gt; 1)</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelPageR compute: numMessages is bigger than buffer size&quot;</span>&lt;&lt; endl;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="comment">// computing the new rank from the input messages</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordflow">for</span>(uint32 loopCount = 0; loopCount &lt; numMessages; loopCount++)<span class="comment">//itm != pIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            newRank += itm-&gt;getContent();</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            ++itm;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        newRank = newRank*0.85 + 0.15/(double)numVertices;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        this-&gt;algData = newRank;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="comment">// now generating the output messages</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        uint32 numOutMessages = 0;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordtype">double</span> messageVal = (this-&gt;algData)/(<span class="keywordtype">double</span>)(this-&gt;get_num_out_edges());</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;get_out_edge_iterator(); ite != this-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        {</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            uint32 dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="comment">//this-&gt;flagActive = true;</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    }</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="classVertexP__pageR.html#a5691c7fb6dcf3e68efe4e5fc1c71d83b">  116</a></span>&#160;    uint32 <a class="code" href="classVertexP__pageR.html#a5691c7fb6dcf3e68efe4e5fc1c71d83b">init</a>(uint32 * pNumVertices, LOCAL_MESSAGE_BUF * pOut)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        numVertices = *pNumVertices;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        this-&gt;algData = 1.0/numVertices;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">double</span> messageVal = (this-&gt;algData)/(<span class="keywordtype">double</span>)(this-&gt;get_num_out_edges());</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        uint32 numOutMessages = 0;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;get_out_edge_iterator(); ite != this-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            uint32 dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;                <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            numOutMessages++;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        this-&gt;flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    }</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;};</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DataType&gt;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;uint32 <a class="code" href="classVertexP__pageR.html">VertexP_pageR&lt;DataType&gt;::numVertices</a>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classPregelCombinerPageR.html">  151</a></span>&#160;<span class="comment"></span><span class="keyword">class </span><a class="code" href="classPregelCombinerPageR.html">PregelCombinerPageR</a>:</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">public</span> <a class="code" href="classPregelCombiner.html">PregelCombiner</a>&lt;DblMessage&gt;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;{</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator   MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <a class="code" href="classPregelCombinerPageR.html">PregelCombinerPageR</a>(){}</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    ~<a class="code" href="classPregelCombinerPageR.html">PregelCombinerPageR</a>(){}</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00162"></a><span class="lineno"><a class="line" href="classPregelCombinerPageR.html#a9cb24077d236de04007cfa277bd05c0d">  162</a></span>&#160;    uint32 <a class="code" href="classPregelCombinerPageR.html#a9cb24077d236de04007cfa277bd05c0d">combineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    {</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;         <span class="keywordflow">return</span> this-&gt;sumCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    }</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;};</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELPAGER_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="Message_8hpp_html"><div class="ttname"><a href="Message_8hpp.html">Message.hpp</a></div><div class="ttdoc">contains core Massage container class for Pregel </div></div>
<div class="ttc" id="classPregelCombinerPageR_html_a9cb24077d236de04007cfa277bd05c0d"><div class="ttname"><a href="classPregelCombinerPageR.html#a9cb24077d236de04007cfa277bd05c0d">PregelCombinerPageR::combineMessages</a></div><div class="ttdeci">uint32 combineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function that calls the generic sum combine </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:162</div></div>
<div class="ttc" id="PregelCombiner_8hpp_html"><div class="ttname"><a href="PregelCombiner_8hpp.html">PregelCombiner.hpp</a></div><div class="ttdoc">contains the definition of the combiner class </div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdef"><b>Definition:</b> Message.hpp:28</div></div>
<div class="ttc" id="classVertexP__pageR_html_a6771c90137d1f5eda92db5e89a43bdc7"><div class="ttname"><a href="classVertexP__pageR.html#a6771c90137d1f5eda92db5e89a43bdc7">VertexP_pageR::numVertices</a></div><div class="ttdeci">static uint32 numVertices</div><div class="ttdoc">numVertices: a static member that holds the total number of vertices </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:57</div></div>
<div class="ttc" id="edge_8hpp_html"><div class="ttname"><a href="edge_8hpp.html">edge.hpp</a></div><div class="ttdoc">contains core edge classes </div></div>
<div class="ttc" id="classEdgeBase_html"><div class="ttname"><a href="classEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">core edge class </div><div class="ttdef"><b>Definition:</b> edge.hpp:30</div></div>
<div class="ttc" id="classPregelCombinerPageR_html"><div class="ttname"><a href="classPregelCombinerPageR.html">PregelCombinerPageR</a></div><div class="ttdoc">Combiner class for the page rank algorithm: it uses sum combining. </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:151</div></div>
<div class="ttc" id="PregelVertex_8hpp_html"><div class="ttname"><a href="PregelVertex_8hpp.html">PregelVertex.hpp</a></div><div class="ttdoc">: core vertex class definitions for pregel engine </div></div>
<div class="ttc" id="classPregelCombiner_html"><div class="ttname"><a href="classPregelCombiner.html">PregelCombiner</a></div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:29</div></div>
<div class="ttc" id="classVertexP__pageR_html_a40963978f9fc2077a6cbc48867c58d45"><div class="ttname"><a href="classVertexP__pageR.html#a40963978f9fc2077a6cbc48867c58d45">VertexP_pageR::VertexP_pageR</a></div><div class="ttdeci">VertexP_pageR(uint32 key)</div><div class="ttdoc">constructor: enable vertex processing even in the absence of messages </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:61</div></div>
<div class="ttc" id="classVertexP__pageR_html"><div class="ttname"><a href="classVertexP__pageR.html">VertexP_pageR</a></div><div class="ttdoc">Customized class for the page rank algorithm by Google as defined in the original Pregel paper...</div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:46</div></div>
<div class="ttc" id="classVertexP__pageR_html_ae5353e8947658bd2c9e42a68bcc17c37"><div class="ttname"><a href="classVertexP__pageR.html#ae5353e8947658bd2c9e42a68bcc17c37">VertexP_pageR::compute</a></div><div class="ttdeci">uint32 compute(MESSAGE_BUF_TYPE *pIn, LOCAL_MESSAGE_BUF *pOut, uint32 numMessages)</div><div class="ttdoc">customized compute function </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:72</div></div>
<div class="ttc" id="classVertexP__pageR_html_a5691c7fb6dcf3e68efe4e5fc1c71d83b"><div class="ttname"><a href="classVertexP__pageR.html#a5691c7fb6dcf3e68efe4e5fc1c71d83b">VertexP_pageR::init</a></div><div class="ttdeci">uint32 init(uint32 *pNumVertices, LOCAL_MESSAGE_BUF *pOut)</div><div class="ttdoc">customized init function </div><div class="ttdef"><b>Definition:</b> pregelPageR.hpp:116</div></div>
<div class="ttc" id="classVertexP_html"><div class="ttname"><a href="classVertexP.html">VertexP</a></div><div class="ttdoc">core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class...</div><div class="ttdef"><b>Definition:</b> PregelVertex.hpp:35</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
